config/routes.rb
Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  get :ping, controller: :heartbeat

  # Defines the root path route ("/")
  root "forms#index"

  get "forms/new" => "forms/change_name#new", as: :new_form
  post "forms/new" => "forms/change_name#create"

  scope "forms/:form_id" do
    get "/" => "forms#show", as: :form
    get "/change-name" => "forms/change_name#edit", as: :change_form_name
    post "/change-name" => "forms/change_name#update"

    scope "/live" do
      get "/" => "forms/live#show_form", as: :live_form
      get "/pages" => "forms/live#show_pages", as: :live_form_pages
    end

    get "/submission-email" => "forms/submission_email#new", as: :submission_email_form
    post "/submission-email" => "forms/submission_email#create"
    get "/confirm-submission-email" => "forms/submission_email#submission_email_code", as: :submission_email_code
    post "/confirm-submission-email" => "forms/submission_email#confirm_submission_email_code", as: :confirm_submission_email_code
    get "/submission-email-confirmed" => "forms/submission_email#submission_email_confirmed", as: :submission_email_confirmed
    get "/email-code-sent" => "forms/submission_email#submission_email_code_sent", as: :submission_email_code_sent

    get "/delete" => "forms/delete_confirmation#delete", as: :delete_form
    delete "/delete" => "forms/delete_confirmation#destroy", as: :destroy_form
    get "/privacy-policy" => "forms/privacy_policy#new", as: :privacy_policy
    post "/privacy-policy" => "forms/privacy_policy#create"
    get "/make-live" => "forms/make_live#new", as: :make_live
    post "/make-live" => "forms/make_live#create", as: :make_live_create
    get "/what-happens-next" => "forms/what_happens_next#new", as: :what_happens_next
    post "/what-happens-next" => "forms/what_happens_next#create", as: :what_happens_next_create
    get "/contact-details" => "forms/contact_details#new", as: :contact_details
    post "/contact-details" => "forms/contact_details#create", as: :contact_details_create
    get "/declaration" => "forms/declaration#new", as: :declaration
    post "/declaration" => "forms/declaration#create", as: :declaration_create

    scope "/pages" do
      get "/" => "pages#index", as: :form_pages
      post "/" => "forms#mark_pages_section_completed"
      post "/move-page" => "pages#move_page", as: :move_page

      scope "/new" do
        get "/type-of-answer" => "pages/type_of_answer#new", as: :type_of_answer_new
        post "/type-of-answer" => "pages/type_of_answer#create", as: :type_of_answer_create
        get "/text-settings" => "pages/text_settings#new", as: :text_settings_new
        post "/text-settings" => "pages/text_settings#create", as: :text_settings_create
        get "/date-settings" => "pages/date_settings#new", as: :date_settings_new
        post "/date-settings" => "pages/date_settings#create", as: :date_settings_create
        get "/selections-settings" => "pages/selections_settings#new", as: :selections_settings_new
        post "/selections-settings" => "pages/selections_settings#create", as: :selections_settings_create
        get "/address-settings" => "pages/address_settings#new", as: :address_settings_new
        post "/address-settings" => "pages/address_settings#create", as: :address_settings_create
        get "/name-settings" => "pages/name_settings#new", as: :name_settings_new
        post "/name-settings" => "pages/name_settings#create", as: :name_settings_create
        get "/" => "pages#new", as: :new_page
        post "/" => "pages#create", as: :create_page
      end

      get "/new-condition" => "pages/conditions#routing_page", as: :routing_page
      post "/new-condition" => "pages/conditions#set_routing_page", as: :set_routing_page

      scope "/:page_id" do
        scope "/conditions" do
          get "/new" => "pages/conditions#new", as: :new_condition
          post "/new" => "pages/conditions#create", as: :create_condition
          get "/:condition_id/edit" => "pages/conditions#edit", as: :edit_condition
          put "/:condition_id" => "pages/conditions#update", as: :update_condition
        end

        scope "/edit" do
          get "/type-of-answer" => "pages/type_of_answer#edit", as: :type_of_answer_edit
          post "/type-of-answer" => "pages/type_of_answer#update", as: :type_of_answer_update
          get "/text-settings" => "pages/text_settings#edit", as: :text_settings_edit
          post "/text-settings" => "pages/text_settings#update", as: :text_settings_update
          get "/date-settings" => "pages/date_settings#edit", as: :date_settings_edit
          post "/date-settings" => "pages/date_settings#update", as: :date_settings_update
          get "/selections-settings" => "pages/selections_settings#edit", as: :selections_settings_edit
          post "/selections-settings" => "pages/selections_settings#update", as: :selections_settings_update
          get "/address-settings" => "pages/address_settings#edit", as: :address_settings_edit
          post "/address-settings" => "pages/address_settings#update", as: :address_settings_update
          get "/name-settings" => "pages/name_settings#edit", as: :name_settings_edit
          post "/name-settings" => "pages/name_settings#update", as: :name_settings_update
          get "/" => "pages#edit", as: :edit_page
          patch "/" => "pages#update", as: :update_page
        end

        scope "/delete" do
          get "/" => "forms/delete_confirmation#delete", as: :delete_page
          delete "/" => "forms/delete_confirmation#destroy", as: :destroy_page
        end
      end
    end
  end

  resources :users, only: %i[index edit update]

  # Page routes
  match "/403", to: "errors#forbidden", as: :error_403, via: :all
  match "/404", to: "errors#not_found", as: :error_404, via: :all
  match "/500", to: "errors#internal_server_error", as: :error_500, via: :all
end

app/models/user.rb
class User < ApplicationRecord
  include GDS::SSO::User

  belongs_to :organisation, optional: true

  serialize :permissions, Array

  enum :role, {
    super_admin: "super_admin",
    editor: "editor",
  }
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  after_action :verify_authorized
  after_action :verify_policy_scoped, only: :index

  rescue_from ActiveRecord::RecordNotFound do
    render template: "errors/not_found", status: :not_found
  end

  def index
    authorize @current_user, :can_manage_user?
    render template: "users/index", locals: { users: policy_scope(User) }
  end

  def edit
    authorize @current_user, :can_manage_user?
    user
  end

  def update
    authorize @current_user, :can_manage_user?
    user.role = user_params[:role]

    if user.save
      redirect_to users_path
    else
      render :edit
    end
  end

private

  def user_params
    params.require(:user).permit(:role)
  end

  def user
    @user ||= User.find(params[:id])
  end
end

app/views/users/edit.html.erb
<% set_page_title(title_with_error_prefix(@user.name, @user.errors.any?)) %>
<% content_for :back_link, govuk_back_link_to(users_path) %>

<div class="govuk-grid-row">
  <div class="govuk-grid-column-two-thirds">
    <h1 class="govuk-heading-l">
      <%= t("users.edit.title") %>
    </h1>

    <h2 class="govuk-heading-m"><%= t("users.edit.caption") %></h2>
    <%= govuk_summary_list(actions: false) do |summary_list|
      summary_list.with_row do |row|
        row.with_key { t('users.index.table_headings.name') }
        row.with_value { @user.name }
      end

      summary_list.with_row do |row|
        row.with_key { t('users.index.table_headings.email') }
        row.with_value { @user.email }
      end

      summary_list.with_row do |row|
        row.with_key { t('users.index.table_headings.organisation') }
        row.with_value { @user.organisation_slug }
      end

      summary_list.with_row do |row|
        row.with_key { t('users.index.table_headings.role') }
        row.with_value { t("users.roles.#{@user.role}.name") }
      end
    end %>

    <%= form_with(model: @user) do |f| %>
      <% if @user.errors.any? %>
        <%= f.govuk_error_summary %>
      <% end %>
      <span class="govuk-caption-l"><%= @item_name %></span>
      <%= f.govuk_collection_radio_buttons :role, user_role_options, :value,:label, :description,
      legend: { text: "Role", size: 'm', tag: 'h2' } %>

    <%= f.govuk_submit t('users.save') do
      govuk_button_link_to t('users.cancel'), users_path, secondary: true
    end %>
  <% end %>

  </div>
</div>

app/views/users/index.html.erb
<% set_page_title(t("users.index.title")) %>
<h1 class="govuk-heading-l"><%= t("users.index.title") %></h1>

<% if users.any? %>
  <%= govuk_table do |table| %>
    <%= table.caption(size: 'm', text: t("users.index.users_caption")) %>

    <%= table.head do |head|
      head.row do |row|
        row.cell(header: true, text: t("users.index.table_headings.name"))
        row.cell(header: true, text: t("users.index.table_headings.email"))
        row.cell(header: true, text: t("users.index.table_headings.organisation"))
        row.cell(header: true, text: t("users.index.table_headings.role"))
      end
    end %>

    <%= table.body do |body|
      users.each do |user|
        body.row do |row|
          row.cell do
            govuk_link_to(user.name, edit_user_path(user))
          end
          row.cell( text: user.email)
          row.cell( text: user.organisation_slug)
          row.cell( text: t("users.roles.#{user.role}.name"))
        end
      end
    end %>
  <% end %>
<% end %>